	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions	
	INCLUDE	i2c.inc		
	INCLUDE	si7021.inc	
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files
	IMPORT	LETIMER_setup	
	IMPORT	I2C1_setup	
	IMPORT	humi
	IMPORT	temp
				
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication
	bl	GPIO_setup		; configure port pins
	bl	LETIMER_setup
	bl	I2C1_setup
	
	OORW	4<<4, GPIO_PF_MODEH, GPIO	; enable power to ENV sensors
	OORW	1<<9, GPIO_PF_DOUT		
	bl	SI7021_request_conversion
loop					
	wfi
	bl	SI7021_get_temp_humi
	bl	SI7021_request_conversion

	ldr	R0, =temp
	ldr	R0, [R0]		; get temp from RAM
	bl	WriteInt
	mov	R0, #''		; print degree symbol
	bl	WriteChar
	mov	R0, #'C'
	bl 	WriteChar
	mov	R0, #' '
	bl	WriteChar
	
	ldr	R0, =humi
	ldr	R0, [R0]		; get humi from RAM
	bl	WriteInt	
	mov	R0, #'%'
	bl	WriteChar
	bl	NewLine
		
	b	loop			; repeat periodic task		
	ENDP

	ALIGN
	END