	INCLUDE EFR32MG12.inc			; CPU register definitions
	INCLUDE	i2c.inc	
	IMPORT	I2Cbuf	

SI7021_SLAVE_ADDRESS	EQU	0x40    	; sensor slave address

;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
humi	SPACE	4
temp	SPACE	4	
	EXPORT	humi
	EXPORT	temp				
		
	AREA    |.text|, CODE, READONLY		; another section in the CODE area	
;-------------------------------------------------------------------------------
SI7021_request_conversion	PROC
	EXPORT	SI7021_request_conversion
	push	{LR, R0-R2}			; save used regs	
	PUTB	0xF5, 0, I2Cbuf			; command	
	mov	R0, #SI7021_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #1
	bl	I2CMasterWriteBuf
	pop	{PC, R0-R2}
	ENDP
		
;-------------------------------------------------------------------------------
SI7021_get_temp_humi	PROC
	EXPORT	SI7021_get_temp_humi
	push	{LR, R0-R2}			; save used regs
	mov	R0, #SI7021_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #2				; read 2 bytes
	bl	I2CMasterReadBuf2

	ldrb	R0, [R1]
	ldrb	R2, [R1, #1]	
	lsl	R0, #8
	add	R0, R2				; raw humi value
	mov	R2, #125
	mul	R0, R2	
	add	R0, #0x8000			; humi = (R0 * 125 + 0x8000)/(2^16) - 6
	lsr	R0, #16
	sub	R0, #6				; R0 = humi
	ldr	R1, =humi
	str	R0, [R1]			; save humi in RAM
	
	mov	R0, #SI7021_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #2				; read 2 bytes
	mov	R3, #0xE0			; get temp command
	bl	I2CMasterReadBuf
	
	ldrb	R0, [R1]
	ldrb	R2, [R1, #1]	
	lsl	R0, #8
	add	R0, R2				; raw temp value
	mov	R2, #176
	mul	R0, R2	
	add	R0, #0x8000			; temp = (R0 * 175.72 + 0x8000)/(2^16) - 46.85
	lsr	R0, #16
	sub	R0, #47				; R0 = temp
	ldr	R1, =temp
	str	R0, [R1]			; save temp in RAM	

	pop	{PC, R0-R2}
	ENDP

	ALIGN
	END	